unit CiaLogonTest1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  uCiaLogon, StdCtrls, ExtCtrls;

const
   WM_DORCVD =    WM_USER + 1;

{  The TMyServer is just to demonstrate a server that will ask for
   username and password }

type
  TMyServer = class
  private
    FState: integer;
    FOnRcvData: TNotifyEvent;
    FTimer: TTimer;
    procedure DoRcvd;
  public
    Rcvd: string;
    procedure Start;
    function  Send(const ToSend: string): string;
    property OnRcvData: TNotifyEvent read FOnRcvData write FOnRcvData;
  end;

type
  TForm1 = class(TForm)
    Logon: TCiaLogon;
    Memo1: TMemo;
    Panel1: TPanel;
    StartBtn: TButton;
    procedure StartBtnClick(Sender: TObject);
    procedure LogonRcvdMatch(Sender: TObject; Event: Word);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    User: Word;
    Pass: Word;
    MyServer: TMyServer;
    procedure MyServerRcvData(Sender: TObject);
    procedure WMDoRcvd(var Msg: TMessage); message WM_DORCVD;
  public
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//------------------------------------------------------------------------------
//---- TMyServer ---------------------------------------------------------------
//------------------------------------------------------------------------------
procedure TMyServer.Start;
begin
   FState := 0;
   PostMessage(Form1.Handle, WM_DORCVD, 0, 0);
end;

//------------------------------------------------------------------------------
procedure TMyServer.DoRcvd;
begin
   case FState of
      0: Rcvd := 'Welcome to MyServer'#13#10 +
                 'Enter username:';
      1: Rcvd := 'Enter password:';
      else
         Exit;
   end;
   Inc(FState);
   if Assigned(FOnRcvData) then
      FOnRcvData(Self);
end;

//------------------------------------------------------------------------------
function TMyServer.Send(const ToSend: string): string;
begin
   Result := ToSend;
   PostMessage(Form1.Handle, WM_DORCVD, 0, 0);
end;

//------------------------------------------------------------------------------
//---- Form events -------------------------------------------------------------
//------------------------------------------------------------------------------
procedure TForm1.WMDoRcvd(var Msg: TMessage);
begin
   // only needed to not have a closed loop with MyServer
   // in real world it will be never
   MyServer.DoRcvd;
end;

//------------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
   MyServer := TMyServer.Create;
   MyServer.OnRcvData := MyServerRcvData;
end;

//------------------------------------------------------------------------------
procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   MyServer.Free;
end;

//------------------------------------------------------------------------------
procedure TForm1.StartBtnClick(Sender: TObject);
begin
   //Logon.ClearEvents;
   User := Logon.AddEvent('username:');
   Pass := Logon.AddEVent('password:');
   MyServer.Start;
end;

//------------------------------------------------------------------------------
//---- Called when we receive data ---------------------------------------------
//------------------------------------------------------------------------------
procedure TForm1.MyServerRcvData(Sender: TObject);
begin
   with Sender as TMyServer do
   begin
      Memo1.Lines.Add(Rcvd);
      Logon.Add(PChar(Rcvd), Length(Rcvd));
   end;
end;

//------------------------------------------------------------------------------
//---- Called when there's a match in received chunck --------------------------
//------------------------------------------------------------------------------
procedure TForm1.LogonRcvdMatch(Sender: TObject; Event: Word);
var
   Sent: string;
begin
   if Event = User then
      Sent := MyServer.Send('wilfried')
   else if Event = Pass then
      Sent := MyServer.Send('mypass');

   With Memo1 do
      Lines[Lines.Count - 1] := Lines[Lines.Count - 1] + ' ' + Sent;
end;

end.
